"""
初始化数据的脚本
"""
import sqlalchemy as sa
from sqlalchemy import Integer, String
from sqlalchemy.orm import declarative_base, mapped_column, sessionmaker
from typing_extensions import Annotated


class Database:
    int_pk = Annotated[int, mapped_column(Integer, primary_key=True)]
    str_required_unique = Annotated[str, mapped_column(String(64), unique=True, nullable=False)]
    str_required = Annotated[str, mapped_column(String(64), nullable=False)]

    def __init__(self, db_url):
        self.engine = sa.create_engine(db_url, echo=False, future=True, pool_size=10, pool_recycle=3600)
        self.Session = sessionmaker(bind=self.engine)
        self.Base = declarative_base()

    def initialize_data(self):
        from src.entity.account import Account, AccountType
        from src.entity.user import User
        session = self.Session()

        user = User(username='zayac', password='123456', name='蓝胖', email='stupidzayac@gmail')
        account = [Account(username='ky3tg107032', password='tg666888', type=AccountType.ky,
                           headers={'sec-ch-ua': '"Not_A Brand";v="8", "Chromium";v="120"',
                                    'x-api-token': 'DL_21f490b93c4fc4db0faf5d0458b6bee2',
                                    'x-api-xxx': '7306dfacdddf5be53c9be3588d9669b9a0d65d0e2fc51e4dd61aa551b5eead68',
                                    'x-api-version': '1.0.0', 'sec-ch-ua-mobile': '?0',
                                    'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/120.0.0.0 Safari/537.36',
                                    'content-type': 'application/json',
                                    'x-api-uuid': '22958E8F-C36B-4C81-AF3F-02A7E6A4DCF2',
                                    'referer': 'https://www.arv5e7.com:6001/app/home?showWelcome=false',
                                    'x-api-client': 'agent_web',
                                    'sec-ch-ua-platform': '"Windows"'},
                           url='https://www.arv5e7.com:6001',
                           name='ky32线',
                           x_api_token='DL_21f490b93c4fc4db0faf5d0458b6bee2',
                           user=user),
                   Account(username='htg51120', password='tg666888', type=AccountType.hth,
                           headers={'sec-ch-ua': '"Not_A Brand";v="8", "Chromium";v="120"',
                                    'x-api-token': 'DL_f55c9588cf34b7e81413bc23f0c9d114',
                                    'x-api-xxx': '40ef612c97c7673f32c7f1367ed5349519350adc2638f2245a53d39527e50f2c',
                                    'x-api-version': '1.0.0', 'sec-ch-ua-mobile': '?0',
                                    'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/120.0.0.0 Safari/537.36',
                                    'content-type': 'application/json',
                                    'x-api-uuid': '2140DC1C-4343-4AF2-9B20-814457DBC3EC',
                                    'referer': 'https://www.oy9eux.com:9514/app/home?showWelcome=false',
                                    'x-api-client': 'agent_web', 'sec-ch-ua-platform': '"Windows"'},
                           url='https://www.oy9eux.com:9514',
                           name='hth20线',
                           x_api_token='DL_f55c9588cf34b7e81413bc23f0c9d114',
                           user=user
                           )]
        self.Base.metadata.create_all(self.engine)
        session.add(user)
        session.add_all(account)
        session.commit()


db = Database('mysql+mysqlconnector://ky_tools:HJQY35seXen8patn@1panel.stupidpz.com:3306/ky_tools')
