# threadpool_manager.py
from PyQt6.QtCore import QThreadPool

# 创建一个全局的线程池实例
pyqt_thread_pool = QThreadPool.globalInstance()

from concurrent.futures import ThreadPoolExecutor


class ThreadPoolManager:
    _instance = None

    def __new__(cls, *args, **kwargs):
        if not cls._instance:
            cls._instance = super(ThreadPoolManager, cls).__new__(cls, *args, **kwargs)
            cls._instance.thread_pool = ThreadPoolExecutor(max_workers=5)
        return cls._instance

    def get_thread_pool(self):
        return self.thread_pool


global_thread_pool = ThreadPoolManager().get_thread_pool()
